//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSpriteNode extends MSBScriptNode;

var MSBSpritePawn BasePawn;
var float GroundSpeed;
var vector initialLocation;
var rotator initialRotation;

// we change the order of Node initialisation because we need to initialise first!
function initialize()
{
 local Action_ChangeScript cs;
 local int l;

 Log(self);

 //remove all Actions
 if (Actions.Length>0)
  Actions.Remove(0,Actions.length);

 //fill sequence with Node-specific Actions first
 fillSequence();

 // initialize all linked sequences
 if (OurNextScript!=None && OurNextScript.IsA('MSBScriptNode'))
   MSBScriptNode(OurNextScript).initialize();


 // set changeScript Action at the end;
 cs= new(None) class'Action_CHANGESCRIPT';
 cs.NextScript=OurNextScript;
 l=Actions.Length;
 Actions[l]=cs;

}

function fillSequence()
{
local ScriptedSequence sN;

Super.fillSequence();
// setting up our pawn
BasePawn.SetPhysics(PHYS_None);
BasePawn.SetLocation(initialLocation);
BasePawn.SetRotation(initialRotation);
if (!BasePawn.disablePhysics)
  BasePawn.SetPhysics(PHYS_Walking);

for (sN=OurNextScript;sN!=None;sN=MSBScriptNode(sN).OurNextScript)
   MSBScriptNode(sN).sP=BasePawn;
}

function Reset()
{
local int i;
super.Reset();
// setting up our pawn
BasePawn.SetPhysics(PHYS_None);
BasePawn.SetLocation(initialLocation);
BasePawn.SetRotation(initialRotation);
if (!BasePawn.disablePhysics)
  BasePawn.SetPhysics(PHYS_Walking);

BasePawn.MoveTarget=None;
for (i=0;i<4;i++)
  BasePawn.ScriptAni[i]=None;
BasePawn.GotoState('Idle');
}

DefaultProperties
{
Description="SpriteLink"
}
