class MSBNodeInButton extends MSBTwoStepButton;

var MSBNodeOutButton ParentNode;
var MSBNodeButton myNode;

var color lineColor;
var int lineXLength;
var float lineYLength;

var float widthExRel,
          heightExRel,
          widthRelBase,
          widthEx,
          heightEx;

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
MSBSceneEditorHud(M.myHUD).bOut=false;
}

function LeftBtnFinished(Canvas C)
{
super.LeftBtnFinished(C);
if (Mouse.hudTargetActor!=None && Mouse.hudTargetActor.IsA('MSBNodeOutButton'))
  {
  //clear Old Connections and establish new ones
  if (!Mouse.bShiftDown)  //multilink when Shift is pressed
    ClearLinks();
  ParentNode=MSBNodeOutButton(Mouse.hudTargetActor);
  ParentNode.ClearLinks();
  ParentNode.ChildNode=self;
  if (ParentNode.myNode!=None)
    ParentNode.myNode.Order.OurNextScript=myNode.Order;
  else
    ParentNode.myScript.Order.OurNextScript=myNode.Order;
  }

if (Mouse.hudTargetActor==None)
    ClearLinks();
}

function ClearLinks()
{
if (ParentNode!=None)
 {
 ParentNode.ChildNode=None;
 if (ParentNode.myNode!=None)
   ParentNode.myNode.Order.OurNextScript=None;
 else
   ParentNode.myScript.Order.OurNextScript=None;
 ParentNode=None;
 }
}

function initButton(Canvas C)
{
xPos=myNode.xPos;
yPos=myNode.yPos-height;
super.initButton(C);
if (!bOver && widthRel>widthRelBase)
  {
  widthRel-=4;
  heightRel-=4;
  }
}

function Render(Canvas C)
{
local float hLength,
            hSplitPos,
            vSplitPos,
            vLength;

if (myNode.bContained)
  return;

if (widthExRel>0)
  {
  widthEx=widthExRel*C.ClipY/768;
  heightEx=heightExRel*C.ClipY/768;
  }

super.Render(C);

if (hasClicked)
  {
  hLength=Mouse.xPos-(xPos+width);
  hSplitPos=hLength/2+xPos+width;
  vLength=Mouse.yPos-(yPos+height/2);
  vSplitPos=Mouse.yPos;

  C.SetDrawColor(lineColor.R,lineColor.G,lineColor.B);
  C.SetPos(xpos+width,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);

  C.SetPos(hSplitPos,ypos+height/2);
  C.DrawRect(Texture'engine.WhiteSquareTexture', 1, vLength);

  C.SetPos(hSplitPos,vSplitPos);
  C.DrawRect(Texture'engine.WhiteSquareTexture', hLength/2, 1);
  C.SetDrawColor(col.R,col.G,col.B);
  }
}






function MouseOver(Canvas C)
{
super.MouseOver(C);
if (widthRel<widthEx)
  {
  widthRel+=4;
  heightRel+=4;
  }
}


defaultproperties
{
tooltip1="Link to Parent"
tooltip2="select Parent Node"
Mat=Texture'MoviesandboxTextures.Icons.NodeIn'
widthRel=16
heightRel=16
widthRelBase=16
widthExRel=24
heightExRel=24
lineColor=(R=255,G=0,B=0,A=255)
}
