class MSBPoseEditor extends MSBListButton;

var array<string> BtnNames;

var Actor PoseActor;
var int focusBone, lastbone;
var string saveName, loadName;

var MSBBoneRotDummy BRD;
var MSBAniPose Pose;

function LeftBtn(Canvas C)                      //opens PoseEditing Buttons
{
local int i;
super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
   {
    if (ListButton[i]!=None  && ListButton[i].IsA('MSBPropertyButton'))
     {
     MSBPropertyButton(ListButton[i]).BtnName=BtnNames[i];
     MSBPropertyButton(ListButton[i]).Parent=self;
     }
    }
iniSubObjects();
assignButtonPrefs();
}

function Trigger(Actor Other, PAwn EventInstigator)
{
// new Actor Assigned
if (Other==ListButton[0] && PoseActor!=None)
  {
  PoseActor.SetPhysics(PHYS_None);
  PoseActor.StopAnimating(true);
  Log("MSBPoseEditor calling Pose.Initialize");
  Pose.initialize(PoseActor);
  Log("MSBPoseEditor called Pose.Initialize");
  BRD.initialize(PoseActor,Pose);
  if (PoseActor.IsA('MSBPawn'))
    lastbone=26;
  if (PoseActor.IsA('MSBFullRig'))
    lastbone=63;
  Log("From MSBPoseEditor:LastBone="$lastbone);
  }

// changed FocusBone
if (Other==ListButton[1])
  {
  if (focusbone==lastbone-1)
    focusbone=0;
  BRD.switchBone(++focusbone);
  }

if (Other==ListButton[2])
  {
  if (focusbone==1)
    focusbone=lastbone;
  BRD.switchBone(--focusbone);
  }

loadname="";
saveName="";
}

function savePose()
{
local int i;
local MSBAniKey A;
local bool bOverwrite;

Log("saving Pose List!");
for(i=0;i<lastbone;i++);
  MSBPawn(PoseActor).PoseKey[i]=None;

for (i=0;i<lastbone;i++)
  {
  A=Level.Game.CreateDataObject(class'MSBAniKey',savename$"Key"$i,"MSBPose_"$SaveName);
  A.BoneRotation=Pose.PoseKey[i].BoneRotation;
  }
Level.Game.SavePackage("MSBPose_"$SaveName);

//update SavePose List
for (i=0;i<M.SavePoses.length;i++)
  if (saveName==M.SavePoses[i])
     bOverwrite=true;
if (!bOverwrite)
  M.SavePoses[M.SavePoses.Length]=saveName;
M.SaveGeneralConfig();
}

function iniSubObjects()
{
Pose=new class'MSBAniPose';
focusBone=1;

BRD=Spawn(class'MSBBoneRotDummy');
//position BoneRotationDummy
if (PoseActor!=None)
  {
  Pose.initialize(PoseActor);
  BRD.initialize(PoseActor,Pose);
  }
Log("MSBPoseEditor iniSubObjects");
}

function assignButtonPrefs()
{
if (ListButton.length>0 && ListButton[0]!=None && ListButton[0].IsA('MSBPropertyButton'))
  {
  MSBPropertyButton(ListButton[0]).Property="PoseActor";
  MSBPropertyButton(ListButton[0]).Value="PoseActor";
  }
if (ListButton.length>3 && ListButton[3]!=None && ListButton[3].IsA('MSBPropertyButton'))
  MSBPropertyButton(ListButton[3]).Parent=BRD;
if (ListButton.length>4 && ListButton[4]!=None && ListButton[4].IsA('MSBPropertyButton'))
  MSBPropertyButton(ListButton[4]).Parent=BRD;
if (ListButton.length>6 && ListButton[5]!=None && ListButton[5].IsA('MSBPoseLoadButton'))
  MSBPoseLoadButton(ListButton[5]).Parent=self;
if (ListButton.length>5 && ListButton[6]!=None && ListButton[6].IsA('MSBPoseSaveButton'))
  MSBPoseSaveButton(ListButton[6]).Parent=self;
}

event Destroyed()
{
Log("Destroying PoseEditor!");
super.Destroyed();
if (BRD!=None)
  BRD.destroy();
Pose=None;
}

function deSelect()
{
Log("deselecting PoseEditor");
super.deSelect();
}

defaultproperties
{
lastbone=26
ButtonList(0)="MSBPropertyButtons.MSBPropertyButton3D"     //select Pawn
BtnNames[0]="select Pawn"
ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonAssign" //next Bone
BtnNames[1]="next Bone"
ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonAssign" //prev Bone
BtnNames[2]="prev Bone"
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonRotate" //rotate DummyObject
BtnNames[3]="rotate"
ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonMoveOrigin" //Move origin
BtnNames[4]="set Origin"
ButtonList(5)="MSBCode.MSBPoseLoadButton"   //load Pose
BtnNames[5]="load Pose"
ButtonList(6)="MSBCode.MSBPoseSaveButton"   //save Pose
BtnNames[6]="save Pose"

Mat=Texture'MoviesandboxTextures.Icons.PoseIcon'
}


