//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonComplex extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> ButtonName;
var array<String> ButtonProperty;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;
var bool bPassOnParent;

//Buttonlist page system:
var int lastpage,maxButtons,maxListSize,currentpage,additionalButtons;

function fillButtonList();

function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);

fillButtonList();

if ((currentpage+1)*maxListSize<=Buttonlist.length + additionalButtons)
  maxButtons=(currentpage+1)*maxListSize;
else
  maxButtons=Buttonlist.length + additionalButtons;

// revisit button distribution...
for (i=currentpage*maxListSize;i<maxButtons; i++)
  {
  if (ButtonList[i]!="")
    {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass,self,,M.Location);
    ListButton[i].SubLevel=SubLevel+1;
    positionButton(C,i);
    if (ListButton[i].IsA('MSBPropertyButton'))
      {
      MSBPropertyButton(ListButton[i]).Property=ButtonProperty[i];
      if (bPassOnParent)
        MSBPropertyButton(ListButton[i]).Parent=self.Parent;
      else
        MSBPropertyButton(ListButton[i]).Parent=self;
      if (ButtonName.length>i && ButtonName[i]!="")
        ListButton[i].BtnName=ButtonName[i];
      }
    }
  }

if (Buttonlist.length>maxListSize)
  {
  //create next/prev page buttons
  ListButton[i]=Spawn(class'MSBNextPageButton',self,,M.Location);
  MSBNextPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;

  ListButton[++i]=Spawn(class'MSBPrevPageButton',self,,M.Location);
  MSBPrevPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;
  }
LeftBtnFinished(C);
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
C.SetPos(xpos+width,ypos);
if (Parent!=None && Parent.IsA('MSBNodeButton'))
  C.DrawText(MSBNodeButton(Parent).Order.GetPropertyText(Property));
}

function positionButton(Canvas C,int i)
{
if (ListButton[i].height<60)
  ListButton[i].xPos=xpos+width;
else
  {
  ListButton[i].xPos=xpos-16 -2*width;
  if (Listbutton[i].xPos<C.ClipX)
    ListButton[i].xPos=xpos+16+2*width;
  }
if (i>currentpage*maxListSize)
  {                          //horizontal alignment
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
    {
    ListButton[i].ypos=yPos-(i*ListButton[i].height+height+1);
    }
  }
else
  ListButton[i].yPos=ypos;
}

DefaultProperties
{
Col=(R=128,G=64,B=64)
maxListSize=5
bPassOnParent=false
}
