//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSceneLoadButton extends MSBListButton;


var string sgName;

event PostBeginPlay()
{
local int i;

super.PostBeginPlay();

for (i=0;i<M.SaveGames.length;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
}


function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

for (i=currentpage*8;i<maxButtons;i++)
  {
  if (ListButton[i].IsA('MSBPropertyButton'))
    {
    MSBPropertyButton(ListButton[i]).Property="sgName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName=M.SaveGames[i];
    }
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
LoadMSBSet(sgName);
}

function LoadMSBSet(string loadName, optional bool bInitial)
{

local MSBDataObject Load;
local int currentItem,i;
local MSBNodeButton N;
local MSBScriptNodeButton S;
local MSBContainerButton C;
local MSBExtendedListButton L;
local MSBActor A;
local MSBPawn P;
local class<Actor> ICClass;

Load=Level.Game.LoadDataObject(class'MSBDataObject',loadName,"MSBSave_"$loadName);

//-------------------------------------------------------------
// clear Lists
//-------------------------------------------------------------
for (i=0;i<M.LevelContainers.length;i++)
  {
  Log("Containers in List before cleanup:"@M.LevelContainers.length);
  M.LevelContainers[i].Destroy();
  }

for (i=0;i<M.LevelNodes.length;i++)
  {
  M.LevelNodes[i].deSelect();
  if (M.LevelNodes[i].NodeIn!=None)
    {
    M.LevelNodes[i].NodeIn.ClearLinks();
    M.LevelNodes[i].NodeIn.Destroy();
    }
  if (M.LevelNodes[i].NodeOut!=None)
    {
    M.LevelNodes[i].NodeOut.ClearLinks();
    M.LevelNodes[i].NodeOut.Destroy();
    }
  M.LevelNodes[i].Order.Destroy();
  M.LevelNodes[i].Destroy();
  }
M.LevelNodes.Remove(0,M.LevelNodes.length);

for (i=0;i<M.LevelMSBScriptNodes.length;i++)
  {
  M.LevelMSBScriptNodes[i].deSelect();
  if (M.LevelMSBScriptNodes[i].NodeOut!=None)
    {
    M.LevelMSBScriptNodes[i].NodeOut.ClearLinks();
    M.LevelMSBScriptNodes[i].NodeOut.Destroy();
    }
  M.LevelMSBScriptNodes[i].Order.Destroy();
  M.LevelMSBScriptNodes[i].Destroy();
  }
M.LevelMSBScriptNodes.Remove(0,M.LevelMSBScriptNodes.length);

for (i=0;i<M.LevelComplexButtons.length;i++)
  M.LevelComplexButtons[i].Destroy();
M.LevelComplexButtons.Remove(0,M.LevelComplexButtons.length);

for (i=0;i<M.LevelActors.length;i++)
  {
  M.LevelActors[i].clearActor();
  M.LevelActors[i].Destroy();
  }
M.LevelActors.Remove(0,M.LevelActors.length);

for (i=0;i<M.LevelPawns.length;i++)
  {
  M.LevelPawns[i].clearPawn();
  M.LevelPawns[i].Destroy();
  }
M.LevelPawns.Remove(0,M.LevelPawns.length);

M.SetLocation(Load.pcLocation);
M.SetRotation(Load.pcRotation);

//-------------------------------------------------------------
// MSBPawns
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myPawnInfos.length;currentItem++)
  {
  P=Spawn(Load.myPawnInfos[currentItem].PawnClass,,,Load.myPawnInfos[currentItem].Location,Load.myPawnInfos[currentItem].Rotation);
  M.LevelPawns[currentItem]=P;
  for (i=0;i<Load.myPawnInfos[currentItem].ButtonList.length;i++)
    {
    P.ButtonList[i]=Load.myPawnInfos[currentItem].ButtonList[i];
    P.Properties[i]=Load.myPawnInfos[currentItem].Properties[i];
    P.SetPropertyText(Load.myPawnInfos[currentItem].Properties[i],Load.myPawnInfos[currentItem].Values[i]);
    }
  //---------------------------------------------------
  //Control related
  //---------------------------------------------------
  for (i=0;i<16;i++)
    {
    P.PoseName[i]=Load.myPawnInfos[currentItem].PoseName[i];
    Log("Loading saved Pad Pose"@P.PoseName[i]);
    }
  P.content=Load.myPawnInfos[currentItem].content;
  if (Load.myPawnInfos[currentItem].DrawScale3D.Z>0)
    P.SetDrawScale3D(Load.myPawnInfos[currentItem].DrawScale3D);
  P.SetCollisionSize(P.default.CollisionRadius,P.default.CollisionHeight*P.DrawScale3D.Z);
  P.channel=Load.myPawnInfos[currentItem].channel;
  P.UdpPadCh=Load.myPawnInfos[currentItem].UdpPadChannel;
  P.OldUdpPadCh=0;
  if (Load.myPawnInfos[currentItem].InputControlClass==None)
    {
    P.MSBPawnInputControl=Spawn(class'MSBPawnInputControl',P,,M.Location);
    Log("No InputControlClass found for this Pawn!");
    }
  else
    {
    P.MSBPawnInputControl=Spawn(Load.myPawnInfos[currentItem].InputControlClass,P,,M.Location);
    Log("InputControlClass"@Load.myPawnInfos[currentItem].InputControlClass@"found for this Pawn!");
    }
  P.LoadCharacter();

  //setup PadControl and Lipsync and Load Content
  P.Trigger(self,None);
  Log("sent ini Trigger to Pawn with UDP"@P.UdpPadCh@"and channel"@P.channel);
  }


//-------------------------------------------------------------
// MSBActors
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myActorInfos.length;currentItem++)
  {
  A=Spawn(Load.myActorInfos[currentItem].ActorClass,,,Load.myActorInfos[currentItem].Location,Load.myActorInfos[currentItem].Rotation);
  A.initialLocation=Load.myActorInfos[currentItem].Location;
  A.initialRotation=Load.myActorInfos[currentItem].Rotation;
  if (Load.myActorInfos[currentItem].DrawScale3D.Z>0)
    A.SetDrawScale3D(Load.myActorInfos[currentItem].DrawScale3D);
  A.SetCollisionSize(A.default.CollisionRadius,A.default.CollisionHeight*A.DrawScale3D.Z);
  A.content=Load.myActorInfos[currentItem].content;
  M.LevelActors[currentItem]=A;
  for (i=0;i<Load.myActorInfos[currentItem].ButtonList.length;i++)
    {
    A.ButtonList[i]=Load.myActorInfos[currentItem].ButtonList[i];
    A.Properties[i]=Load.myActorInfos[currentItem].Properties[i];
    Log("Actor Properties:"@A.Properties[i]);
    if (A.ButtonList[i]!="MSBPropertyButtons.MSBPropertyButton3D")
      A.SetPropertyText(Load.myActorInfos[currentItem].Properties[i],Load.myActorInfos[currentItem].Values[i]);
    }
  if (A.bInputControlled)
    {
    ICClass=class<actor>(DynamicLoadObject(A.InputControlClassName, class'Class'));
    A.MSBInputControl=Spawn(ICClass,A,,A.Location,A.Rotation);
    A.MSBInputControl.Trigger(self, None);
    }

  A.LoadProp();
  A.SetRotation(Load.myActorInfos[currentItem].Rotation);
  }

//-------------------------------------------------------------
// MSBActor Attachments
//-------------------------------------------------------------
for (currentItem=0;currentItem<M.LevelActors.length;currentItem++)
  if (Load.myActorInfos[currentItem].attachedTo>0)
    M.LevelActors[currentItem].AttachedTo=M.LevelActors[Load.myActorInfos[currentItem].attachedTo-1];
  else if (Load.myActorInfos[currentItem].attachedToPawn>0)
    M.LevelActors[currentItem].AttachedTo=M.LevelPawns[Load.myActorInfos[currentItem].attachedTo-1];
  else if (Load.myActorInfos[currentItem].attachedToSpecial>0)
    M.LevelActors[currentItem].AttachedTo=M.LevelSpecial[Load.myActorInfos[currentItem].attachedTo-1];

//-------------------------------------------------------------
// MSBActor KeyFrames
//-------------------------------------------------------------
for (currentItem=0;currentItem<M.LevelActors.length;currentItem++)  //traverse all Actors' KeyFrames
  for (i=0;i<Load.myActorInfos[currentItem].KeyFrames.length;i++)
    M.LevelActors[currentItem].Keys[i]=MSBKeyFrame(M.LevelActors[Load.myActorInfos[currentItem].KeyFrames[i]-1]);

//-------------------------------------------------------------
// MSBActor Cross Referencing
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myActorInfos.length;currentItem++)  //traverse all Actors PropertyButtons and connect Prop3D Properties to Actors
  {
  A=M.LevelActors[currentItem];
  for(i=0;i<A.Properties.length;i++)
    {
    if (i<Load.myActorInfos[currentItem].ActorReference.Length && Load.myActorInfos[currentItem].ActorReference[i]>0)
      A.SetPropertyText(Load.myActorInfos[currentItem].Properties[i],String(M.LevelActors[Load.myActorInfos[currentItem].ActorReference[i]-1]));

    else if (i<Load.myActorInfos[currentItem].PawnReference.Length && Load.myActorInfos[currentItem].PawnReference[i]>0)
      A.SetPropertyText(Load.myActorInfos[currentItem].Properties[i],String(M.LevelPawns[Load.myActorInfos[currentItem].PawnReference[i]-1]));

    else if (i<Load.myActorInfos[currentItem].SpecialReference.Length && Load.myActorInfos[currentItem].SpecialReference[i]>0)
      A.SetPropertyText(Load.myActorInfos[currentItem].Properties[i],String(M.LevelSpecial[Load.myActorInfos[currentItem].SpecialReference[i]-1]));
    }
  }

//-------------------------------------------------------------
// Nodes
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myNodeInfos.Length;currentItem++)
  {
  N=spawn(class'MSBNodeButton',,,M.Location);
  N.xPos=Load.myNodeInfos[currentItem].xPos;
  N.yPos=Load.myNodeInfos[currentItem].yPos;
  N.col=Load.myNodeInfos[currentItem].col;
  if (Load.myNodeInfos[currentItem].bHiddenBranch)
    N.hideNode();
  N.BtnName=Load.myNodeInfos[currentItem].BtnName;

  if (Load.myNodeInfos[currentItem].OrderClass!=None)
    {
    N.Order=Spawn(Load.myNodeInfos[currentItem].OrderClass,,,M.Location);
    if (N.Order==None)
      N.Order=Spawn(Load.myNodeInfos[currentItem].OrderClass,,,0*M.Location);
    }
  for (i=0;i<Load.myNodeInfos[currentItem].ButtonList.length;i++)
    {
    N.ButtonList[i]=Load.myNodeInfos[currentItem].ButtonList[i];
    N.Properties[i]=Load.myNodeInfos[currentItem].Properties[i];

    //---------------------------------
    //set relative Object References
    //---------------------------------
   if (Load.myNodeInfos[currentItem].ActorReference.Length>i && Load.myNodeInfos[currentItem].ActorReference[i]>0 && N.Order!=None)
      {
      N.Order.SetPropertyText(Load.myNodeInfos[currentItem].Properties[i],String(M.LevelActors[Load.myNodeInfos[currentItem].ActorReference[i]-1]));
      }
    else if (Load.myNodeInfos[currentItem].PawnReference.Length>i && Load.myNodeInfos[currentItem].PawnReference[i]>0 && N.Order!=None)
      {
      //----------------------
      //MSBRootNode handling
      //----------------------
      if (N.Order.IsA('MSBRootNode'))
        {
        M.myHUD.RemoveHudOverlay(N.NodeIn);
        MSBRootNode(N.Order).BasePawn=M.LevelPawns[Load.myNodeInfos[currentItem].PawnReference[i]-1];
        MSBRootNode(N.Order).initialLocation=MSBRootNode(N.Order).BasePawn.Location;
        MSBRootNode(N.Order).initialRotation=MSBRootNode(N.Order).BasePawn.Rotation;
        MSBRootNode(N.Order).BasePawn.ControllerClass=class'ScriptedController';
 //       N.Order.SetPropertyText(Load.myNodeInfos[currentItem].Properties[i],String(M.LevelPawns[Load.myNodeInfos[currentItem].PawnReference[i]-1]));
        }
      //----------------------
      //MSBSpriteNode handling
      //----------------------
      else if (N.Order.IsA('MSBSpriteNode'))
        {
        M.myHUD.RemoveHudOverlay(N.NodeIn);
        MSBSpriteNode(N.Order).BasePawn=MSBSpritePawn(M.LevelActors[Load.myNodeInfos[currentItem].PawnReference[i]-1]);
        MSBSpriteNode(N.Order).initialLocation=MSBSpriteNode(N.Order).BasePawn.Location;
        MSBSpriteNode(N.Order).initialRotation=MSBSpriteNode(N.Order).BasePawn.Rotation;
        }
      else
        {
        N.Order.SetPropertyText(Load.myNodeInfos[currentItem].Properties[i],String(M.LevelPawns[Load.myNodeInfos[currentItem].PawnReference[i]-1]));
        }
      }
    else if (Load.myNodeInfos[currentItem].SpecialReference.Length>0 && Load.myNodeInfos[currentItem].SpecialReference[i]>0 && N.Order!=None)
      N.Order.SetPropertyText(Load.myNodeInfos[currentItem].Properties[i],String(M.LevelSpecial[Load.myNodeInfos[currentItem].SpecialReference[i]-1]));
    else if (N.Order!=None)
      N.Order.SetPropertyText(Load.myNodeInfos[currentItem].Properties[i],Load.myNodeInfos[currentItem].Values[i]);
    }
  M.LevelNodes[currentItem]=N;
  }

//-------------------------------------------------------------
// Complex Buttons (MSBExtendedListButtons and children)
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myComplexInfos.length;currentItem++)
  {
  L=Spawn(Load.myComplexInfos[currentItem].ButtonClass,,,M.Location);
  L.xPos=Load.myComplexInfos[currentItem].xPos;
  L.yPos=Load.myComplexInfos[currentItem].yPos;
  L.col=Load.myComplexInfos[currentItem].col;

  L.BtnName=Load.myComplexInfos[currentItem].BtnName;
  for (i=0;i<Load.myComplexInfos[currentItem].ButtonList.length;i++)
    {
    L.ButtonList[i]=Load.myComplexInfos[currentItem].ButtonList[i];
    L.Properties[i]=Load.myComplexInfos[currentItem].Properties[i];

    //---------------------------------
    //set relative Object References
    //---------------------------------
    if (Load.myComplexInfos[currentItem].ActorReference.Length>0 && Load.myComplexInfos[currentItem].ActorReference[i]>0)
      L.SetPropertyText(Load.myComplexInfos[currentItem].Properties[i],String(M.LevelActors[Load.myComplexInfos[currentItem].ActorReference[i]-1]));
    else if (Load.myComplexInfos[currentItem].PawnReference.Length>0 && Load.myComplexInfos[currentItem].PawnReference[i]>0)
      L.SetPropertyText(Load.myComplexInfos[currentItem].Properties[i],String(M.LevelPawns[Load.myComplexInfos[currentItem].PawnReference[i]-1]));
    else if (Load.myComplexInfos[currentItem].SpecialReference.Length>0 && Load.myComplexInfos[currentItem].SpecialReference[i]>0)
      L.SetPropertyText(Load.myComplexInfos[currentItem].Properties[i],String(M.LevelSpecial[Load.myComplexInfos[currentItem].SpecialReference[i]-1]));
    else
      L.SetPropertyText(Load.myComplexInfos[currentItem].Properties[i],Load.myComplexInfos[currentItem].Values[i]);

    }
  M.LevelComplexButtons[currentItem]=L;
  }

//-------------------------------------------------------------
// Link Nodes
//-------------------------------------------------------------
for (currentItem=0;currentItem<M.LevelNodes.length;currentItem++)
  if (Load.myNodeInfos[currentItem].NextNode>0)
    {
      M.LevelNodes[currentItem].NodeOut.ChildNode=M.LevelNodes[Load.myNodeInfos[currentItem].NextNode-1].NodeIn;
      M.LevelNodes[Load.myNodeInfos[currentItem].NextNode-1].NodeIn.ParentNode=M.LevelNodes[currentItem].NodeOut;
      M.LevelNodes[currentItem].Order.OurNextScript=M.LevelNodes[Load.myNodeInfos[currentItem].NextNode-1].Order;
//--------- RootNode NodeOut Hiding
      if (M.LevelNodes[currentItem].Order.IsA('MSBRootNode') && M.LevelNodes[currentItem].NodeOut.ChildNode.myNode.bHiddenBranch)
        M.myHUD.RemoveHudOverlay(M.LevelNodes[currentItem].NodeOut);
    }

//-------------------------------------------------------------
// MSBScriptNodes
//-------------------------------------------------------------
for (currentItem=0;currentItem<Load.myMSBScriptNodeInfos.length;currentItem++)
  {
  S=Spawn(Load.myMSBScriptNodeInfos[currentItem].myClass,,,M.Location);
  //---------------------------------------------------------
  //General Button Properties
  //---------------------------------------------------------
  S.xPos=Load.myMSBScriptNodeInfos[currentItem].xPos;
  S.yPos=Load.myMSBScriptNodeInfos[currentItem].yPos;
  S.col=Load.myMSBScriptNodeInfos[currentItem].col;
  S.BtnName=Load.myMSBScriptNodeInfos[currentItem].BtnName;
  //---------------------------------------------------------
  //Properties and Buttons - viable for KeyInput etc...
  //---------------------------------------------------------
  for (i=0;i<Load.myMSBScriptNodeInfos[currentItem].ButtonList.length;i++)
    {
    S.ButtonList[i]=Load.myMSBScriptNodeInfos[currentItem].ButtonList[i];
    S.Properties[i]=Load.myMSBScriptNodeInfos[currentItem].Properties[i];
    S.SetPropertyText(Load.myMSBScriptNodeInfos[currentItem].Properties[i],Load.myMSBScriptNodeInfos[currentItem].Values[i]);
    }
  //-----------------------------------------
  //Linking to Nodes
  //-----------------------------------------
  if (Load.myMSBScriptNodeInfos[currentItem].NextNode>0)
    {
    S.Order.OurNextScript=M.LevelNodes[Load.myMSBScriptNodeInfos[currentItem].NextNode-1].Order;
    S.NodeOut.ChildNode=M.LevelNodes[Load.myMSBScriptNodeInfos[currentItem].NextNode-1].NodeIn;
    M.LevelNodes[Load.myMSBScriptNodeInfos[currentItem].NextNode-1].NodeIn.ParentNode=S.NodeOut;
    if (S.NodeOut.ChildNode.myNode.bHiddenBranch)
        M.myHUD.RemoveHudOverlay(S.NodeOut);
    }
  //-----------------------------------------
  //Special handling for SpritePawns
  //-----------------------------------------
  if (S.Order.OurNextScript.IsA('MSBSpriteNode'))
    {
    M.myHUD.RemoveHudOverlay(S);
    M.myHUD.RemoveHudOverlay(S.NodeOut);
    }
  }


//-------------------------------------------------------------
// MSBContainers
//-------------------------------------------------------------
Log("Number of containers:"@Load.myContainerInfos.length);

for (currentItem=0;currentItem<Load.myContainerInfos.length;currentItem++)
  {
  Log("Container we are looking at:"@currentItem);
  C=Spawn(Load.myContainerInfos[currentItem].myClass,,,M.Location);

  for (i=0;i<Load.myContainerInfos[currentItem].containedNodes.Length;i++)
    C.containedNodes[i]=Load.myContainerInfos[currentItem].containedNodes[i];

  for (i=0;i<Load.myContainerInfos[currentItem].containedScriptNodes.Length;i++)
    C.containedScriptNodes[i]=Load.myContainerInfos[currentItem].containedScriptNodes[i];

  for (i=0;i<Load.myContainerInfos[currentItem].containedContainers.Length;i++)
    C.containedContainers[i]=Load.myContainerInfos[currentItem].containedContainers[i];

  //---------------------------------------------------
  //General Node Properties are set_
  //---------------------------------------------------
  C.xPos=Load.myContainerInfos[currentItem].xpos;
  C.yPos=Load.myContainerInfos[currentItem].ypos;
  C.col=Load.myContainerInfos[currentItem].col;
  C.BtnName=Load.myContainerInfos[currentItem].btnName;
  if (!Load.myContainerInfos[currentItem].bCollapsed)
    C.hideContent(true);
  }
if (!bInitial)
  deSelectSubLevel();
}


DefaultProperties
{
tooltip="Load Scene"
Mat=Texture'MoviesandboxTextures.Icons.loadScene'
}



