class MSBInstrumentInputControl extends Actor;

var MSBPawn myPawn;
var MSBRagdollPuppet myPuppet;
var MSBUdpLink udpLink;
var () int iPort;   // server port number
var bool bUdpInit;

var array<Sound> Chords[10];
var array<MSBSoundEmitter> mySound[10];
var Byte oldByteData;

event PostBeginPlay()
{
local int i;

super.PostBeginPlay();
if (Owner.IsA('MSBPawn'))
  myPawn=MSBPawn(Owner);

Log("This InstrumentInputControl is Owned by:"@Owner);

for (i=0;i<10;i++)
  mySound[i]=Spawn(class'MSBSoundEmitter',self,,Location,Rotation);

//HACK for Gijon
foreach AllActors(class'MSBRagdollPuppet',myPuppet)
  break;
}

function initUdp()
{
 iPort=31840+myPawn.UdpPadCh;
 if (udpLink!=None)
   udpLink.Destroy();
 udpLink=Spawn(class'MSBUdpLink',self);
 udpLink.InitUdpLink(iPort);
 Log("UdpPort initialized to"@iPort);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local int i;
local rotator HeadTurn;

if (Other.IsA('MSBGuiOverlay'))
  {
  initUdp();
  Log("changed UdpPadChannel in MSBPawnInputControl!");
  }


//udp Gamepad_
if (myPawn!=None && myPawn.UdpPadCh>0 && udpLink!=None)
  {
  for (i=4;i<32;i++)
    if (udpLink.byteData[i]>0 && myPawn.PoseName[i-4]!="")
      {
      myPawn.setPawnPose(myPawn.PoseName[i-4]);
      }
  myPawn.eyeX=udpLink.byteData[0]-128;
  myPawn.eyeY=udpLink.byteData[1]-128;
  //myPawn.browY=udpLink.byteData[1];

  HeadTurn.Yaw=32*(udpLink.byteData[2]-127);
  HeadTurn.Roll=-32*(udpLink.byteData[3]-127);
  if (VSize(vector(HeadTurn))>0)
    myPawn.SetBoneRotation('Bip01 Head',HeadTurn);
  }
playGuitar();
}

function PlayGuitar()
{
local int i;

if (udpLink.byteData[1]!=oldByteData) //Play when strum changed!
  {
  oldByteData=udpLink.byteData[1];
    if (udpLink.byteData[1]<120 || udpLink.byteData[1]>132)    //but not when it's in the middle (including some calibration fuzzyness)
    {
//   Log("we strummed!");
    for (i=4;i<12;i++)   //check eight Buttons
      {
      if (udpLink.byteData[i]>0)
        {
        mySound[i-4].PlaySound(Chords[i-4],,1,false,1024,,false);
        if (myPawn!=None)
          {
          myPawn.setPawnPose(myPawn.PoseName[0]);
          SetTimer(0.4, false);
          }
        if (myPuppet!=None)
          kickFeet(i-4);
        }
      }
    }
  }
}

event Timer()
{
if (myPawn!=None)
  myPawn.setPawnPose(myPawn.PoseName[1]);

//HACK for Gijon
foreach AllActors(class'MSBRagdollPuppet',myPuppet)
  break;
}

event Destroyed()
{
local int i;
udpLink.Destroy();
for (i=0;i<10;i++)
  mySound[i].Destroy();
}

function kickFeet(int num)
{
if (num==0)
  {
  myPuppet.Puppet.KAddImpulse(vect(2,0,0)*1000,myPuppet.Location,'bip01 L thigh');
  myPuppet.Puppet.KAddImpulse(vect(0,0,8)*1000,myPuppet.Location,'bip01 L thigh');
  }
if (num==1)
  {
  myPuppet.Puppet.KAddImpulse(vect(0,-2,0)*1000,myPuppet.Location,'bip01 L thigh');
  myPuppet.Puppet.KAddImpulse(vect(0,0,8)*1000,myPuppet.Location,'bip01 L thigh');
  }

if (num==2)
  {
  myPuppet.Puppet.KAddImpulse(vect(1,2,0)*1000,myPuppet.Location,'bip01 R thigh');
  myPuppet.Puppet.KAddImpulse(vect(0,0,8)*1000,myPuppet.Location,'bip01 R thigh');
  }
if (num==3)
  {
  myPuppet.Puppet.KAddImpulse(vect(-2,1,0)*1000,myPuppet.Location,'bip01 R thigh');
  myPuppet.Puppet.KAddImpulse(vect(0,0,8)*1000,myPuppet.Location,'bip01 R thigh');
  }
}

defaultproperties
{
DrawType=DT_None
iPort=31840
Chords(0)=Sound'BobBlockSounds.E_medium'
Chords(1)=Sound'BobBlockSounds.G_medium'
Chords(2)=Sound'BobBlockSounds.A_medium'
Chords(3)=Sound'BobBlockSounds.C_medium'
Chords(4)=None
Chords(5)=Sound'BobBlockSounds.D_medium'
Chords(6)=None
}
