class MSBRDPuppetInputControl extends Actor;

var MSBRagDollPuppet myPuppet;

var MSBUdpLink udpLink;
var MSBUdpLink udpHeadLink;

var () int iPort;   // server port number
var bool bUdpInit;
var () vector leftDown, rightUp, leftDownTwo, rightUpTwo;

var bool bHeadUp,bHeadDown,bFluffy;

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBRagdollPuppet'))
  myPuppet=MSBRagdollPuppet(Owner);
}

function initUdp()
{
 iPort=31840+myPuppet.UdpPadCh;
 if (udpLink!=None)
   udpLink.Destroy();
 if (myPuppet.UdpPadCh>0)
   {
   udpLink=Spawn(class'MSBUdpLink',self);
   udpLink.InitUdpLink(iPort);
   Log("UdpPort initialized to"@iPort);
   }
 else
   Log("udpLink destroyed");
}
function initHeadUdp()
{
 iPort=31840+myPuppet.UdpHeadPadCh;
 if (udpHeadLink!=None)
   udpHeadLink.Destroy();
 if (myPuppet.UdpHeadPadCh>0)
   {
   udpHeadLink=Spawn(class'MSBUdpLink',self);
   udpHeadLink.InitUdpLink(iPort);
   Log("UdpHeadPort initialized to"@iPort);
   }
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local rotator pOneRot, offset;
local float dataOne;
local float pOneLength;
local vector pOne,X,Y,Z;
local PlayerController PC;

if (Other.IsA('MSBGuiOverlay'))
  {
  initUdp();
  initHeadUdp();
  Log("changed UdpPadChannel in MSBRDPuppetInputControl!");
  }

//udp Gamepad_
if (myPuppet!=None && myPuppet.UdpPadCh>0 && Other==udpLink)
  {
  myPuppet.GetAxes(mypuppet.rotation,X,Y,Z);
  offset.Pitch=16384;
  dataOne=(UdpLink.byteData[6] << 8)+ UdpLink.byteData[7] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLink.byteData[8] << 8)+ UdpLink.byteData[9] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;


  pOneLength=65536 -((UdpLink.byteData[10] << 8) + UdpLink.byteData[11]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;

  myPuppet.leftHandLoc.X=-pOne.X*5+4;
  myPuppet.leftHandLoc.Y=(-pOne.Y*5)-12;
  myPuppet.leftHandLoc.Z=pOne.Z*2-24;

  if (myPuppet.leftHandLoc.X<leftDown.X)
    myPuppet.leftHandLoc.X=leftDown.X;
  if (myPuppet.leftHandLoc.Y<leftDown.Y)
    myPuppet.leftHandLoc.Y=leftDown.Y;
  if (myPuppet.leftHandLoc.Z<leftDown.Z)
    myPuppet.leftHandLoc.Z=leftDown.Z;
  if (myPuppet.leftHandLoc.X>rightUp.X)
    myPuppet.leftHandLoc.X=rightUp.X;
  if (myPuppet.leftHandLoc.Y>rightUp.Y)
    myPuppet.leftHandLoc.Y=rightUp.Y;
  if (myPuppet.leftHandLoc.Z>rightUp.Z)
    myPuppet.leftHandLoc.Z=rightUp.Z;

  myPuppet.leftHandLoc=-myPuppet.leftHandLoc.X*X-myPuppet.leftHandLoc.Y*Y+myPuppet.leftHandLoc.Z*Z;

  dataOne=(UdpLink.byteData[0] << 8)+ UdpLink.byteData[1] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLink.byteData[2] << 8)+ UdpLink.byteData[3] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;


  pOneLength=65536 -((UdpLink.byteData[4] << 8) + UdpLink.byteData[5]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;

  myPuppet.rightHandLoc.X=-pOne.X*5+4;
  myPuppet.rightHandLoc.Y=-pOne.Y*5+12;
  myPuppet.rightHandLoc.Z=pOne.Z*2-24;

  if (myPuppet.rightHandLoc.X<leftDownTwo.X)
    myPuppet.rightHandLoc.X=leftDownTwo.X;
  if (myPuppet.rightHandLoc.Y<leftDownTwo.Y)
    myPuppet.rightHandLoc.Y=leftDownTwo.Y;
  if (myPuppet.rightHandLoc.Z<leftDownTwo.Z)
    myPuppet.rightHandLoc.Z=leftDownTwo.Z;

  if (myPuppet.rightHandLoc.X>rightUpTwo.X)
    myPuppet.rightHandLoc.X=rightUpTwo.X;
  if (myPuppet.rightHandLoc.Y>rightUpTwo.Y)
    myPuppet.rightHandLoc.Y=rightUpTwo.Y;
  if (myPuppet.rightHandLoc.Z>rightUpTwo.Z)
    myPuppet.rightHandLoc.Z=rightUpTwo.Z;

  myPuppet.rightHandLoc=-myPuppet.rightHandLoc.X*X-myPuppet.rightHandLoc.Y*Y+myPuppet.rightHandLoc.Z*Z;
  }

if (myPuppet!=None && myPuppet.UdpPadCh>0 && Other==udpHeadLink)
  {
//****************************************************************************
// HACK: Head Combo for Gijon!
  if ((udpHeadLink.byteData[1]-128)<-100 )
    {
    Log("HeadUp!"@udpHeadLink.byteData[1]-128);
    if (bHeadDown)
      {
      PC=Level.GetLocalPlayerController();
      if (bFluffy)
        PC.ConsoleCommand("BrushesToBlocks");
      else
        PC.ConsoleCommand("BlocksToBrushes");
      bFluffy=!bFluffy;
      bHeadDown=false;
      }
    bHeadUp=true;
    SetTimer(1,false);
    }
  if ((udpHeadLink.byteData[1]-128)>100 && bHeadUp)
    {
    Log("HeadDown!");
     bHeadDown=true;
    }
// end Head Combo
//*****************************************************
  myPuppet.GetAxes(mypuppet.rotation,X,Y,Z);
//  pOne.X=udpHeadLink.byteData[0]-128;
  pOne.Y=-(udpHeadLink.byteData[0]-128)/4;
  pOne.Z=-(udpHeadLink.byteData[1]-128) /4;

 // myPuppet.neckLoc.X=-pOne.X;
  myPuppet.neckLoc.Y=pOne.Y;
  myPuppet.neckLoc.Z=pOne.Z;

  myPuppet.neckLoc=-myPuppet.neckLoc.X*X-myPuppet.neckLoc.Y*Y+myPuppet.neckLoc.Z*Z;
  }
}

event Timer()
{
Log("HeadTimer!");
bHeadUp=false;
}

event Destroyed()
{
udpLink.Destroy();
}

defaultproperties
{
leftDown=(X=-32,Y=-36,Z=-12)
rightUp=(X=0,Y=6,Z=54)
leftDownTwo=(X=-32,Y=-6,Z=-12)
rightUpTwo=(X=0,Y=36,Z=54)

DrawType=DT_None
iPort=31840
}
