class MSBRagdoll extends KActor;

var vector MasterSize;
var array<MSBMasterBlock> Blocks;

var string content;

function LoadProp()
{
local MSBVoxelCharacterSave char;
local int bone,block;
local MSBMasterBlock Master;
local class <MSBVoxelShader> shaderclass;
local int lowestZ;

lowestZ=100000000;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',content,"MSBVoxChar_"$content);
for(bone=0;bone<char.Parts.length;bone++)
  {
    Master=Blocks[bone];
    //get rid of old blocks
    Master.clearBlocks();
    //set new blocks
    for (block=0;block<char.Parts[bone].Col.length;block++)
      {
      Master.S[block]=Spawn(class'MSBsimpleBlock',,,Master.Location);
      Master.S[block].Skins[0]=new() class'ColorModifier';
      ColorModifier(Master.S[block].Skins[0]).Color=char.Parts[bone].Col[block];
      ColorModifier(Master.S[block].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
      Master.S[block].SetDrawScale(char.Parts[Bone].drawScale[block]);
      Master.S[block].initialDrawScale=char.Parts[Bone].drawScale[block];
      Master.AttachToBone(Master.S[Master.S.length-1],'');
      Master.S[block].setRelativeLocation(char.Parts[bone].BlockRelLocation[block] << Master.Rotation);
      Master.S[block].Master=Master;
      if (char.Parts[bone].blockShader.Length>0 && char.Parts[bone].blockShader[block]!="")
        {
        shaderClass=class<MSBVoxelShader>(DynamicLoadObject(char.Parts[bone].blockShader[block],class'Class'));
        Master.S[block].shader= new shaderClass;
        Master.S[block].shader.Parent=Master.S[block];
        }
    Master.SetDrawType(DT_None);
    }
  }
}

function setMSBMasterBlocks()
{
local coords C[26];
local int i;

C[0]=GetBoneCoords('Bip01');

C[1]=GetBoneCoords('Bip01 Pelvis');
C[2]=GetBoneCoords('bip01 Spine');
C[3]=GetBoneCoords('bip01 Spine1');
C[4]=GetBoneCoords('bip01 Spine2');
C[5]=GetBoneCoords('Bip01 Neck');

C[6]=GetBoneCoords('Bip01 R Clavicle');
C[7]=GetBoneCoords('Bip01 R UpperArm');
C[8]=GetBoneCoords('Bip01 R Forearm');
C[9]=GetBoneCoords('Bip01 R Hand');
C[10]=GetBoneCoords('Bip01 R Finger');
C[11]=GetBoneCoords('Bone_weapon');

C[12]=GetBoneCoords('Bip01 L Clavicle');
C[13]=GetBoneCoords('Bip01 L UpperArm');
C[14]=GetBoneCoords('Bip01 L Forearm');
C[15]=GetBoneCoords('Bip01 L Hand');
C[16]=GetBoneCoords('Bip01 L Finger');

C[17]=GetBoneCoords('bip01 R Thigh');
C[18]=GetBoneCoords('Bip01 R Calf');
C[19]=GetBoneCoords('Bip01 R Foot');
C[20]=GetBoneCoords('Bip01 R Toe0');

C[21]=GetBoneCoords('bip01 L Thigh');
C[22]=GetBoneCoords('Bip01 L Calf');
C[23]=GetBoneCoords('Bip01 L Foot');
C[24]=GetBoneCoords('Bip01 L Toe0');

C[25]=GetBoneCoords('Bip01 Head');

for (i=0;i<26;i++)
  {
  Blocks[i]=Spawn(class'MSBMasterBlock',self,,C[i].Origin);
  Blocks[i].BoneNumber=i;
  Blocks[i].P=self;
  }
}

function clearPawn()
{
local int i;

for (i=0;i<26;i++)
  {
  Blocks[i].clearBlocks();
  Blocks[i].Destroy();
  }
}


simulated event TriggerEvent(Name EventName,Actor Other,Pawn EventInstigator)
{
if (EventName=='RunMovie')
  SetPhysics(PHYS_KarmaRagDoll);

if (EventName=='StopMovie')
  SetPhysics(PHYS_None);

}


defaultproperties
{
bHidden=false
bStatic=false
bNoDelete=false
Physics=PHYS_None
DrawType=DT_Mesh
Mesh=Mesh'ThunderCrash.JakobM'

//StaticMesh=StaticMesh'BulldogMeshes.Simple.S_RearWheel'
DrawScale= 1
CollisionHeight=12
CollisionRadius=12
bBlockActors=false
bCollideActors=false
bUseCylinderCollision=false
ImpactInterval=0.001000
    Begin Object Class=KarmaParamsSkel Name=KarmaParamsSkel0
        KLinearDamping=1.8
        KAngularDamping=1.0
        KMass=1
        KActorGravScale=0.5
        KStartEnabled=True
        bHighDetailOnly=False
        bKAllowRotate=True
//        bKDoubleTickRate=true
//        bDoSafetime=true
        KFriction=0.0100000
        KRestitution=0.8000000
        KImpactThreshold=0.000000
        KSkeleton="Male2"
    End Object
KParams=KarmaParamsSkel'KarmaParamsSkel0'

Skins(0)=Material'MovieSandboxTextures.Transparent'
Skins(1)=Material'MovieSandboxTextures.Transparent'
Skins(2)=Material'MovieSandboxTextures.Transparent'
Skins(3)=Material'MovieSandboxTextures.Transparent'

}
