class MSBSimpleBlock extends MSBActor;

var vector myLoc;
var MSBMasterBlock Master;
var vector iniRelLocation;
var float initialDrawScale;
var bool bEdit;
var bool bNoRotate;
var MSBVoxelShader shader;

var StaticMesh DebugStaticMesh;

event PostBeginPlay()
{
super.PostBeginPlay();
}

function Tick(float DeltaTime)
{
if (bDisplayed)
  bHidden=Master.Owner.bHidden;
else
  bHidden=true;

if (!bEdit)
  {
  if (VSize(iniRelLocation)==0)
    iniRelLocation=relativeLocation;
  SetRelativeLocation(iniRelLocation*Master.P.DrawScale);
  SetDrawScale(initialDrawScale*Master.P.DrawScale);
  if (bNoRotate)
    SetRotation(0*Rotation);
  }
else
  {
  if (VSize(iniRelLocation)==0)
    iniRelLocation=relativeLocation;
  SetRelativeLocation(iniRelLocation<<Master.rotation);
  if (bNoRotate)
    SetRotation(0*Rotation);
  }
if (shader!=None && shader.parent==self)
  shader.shade(DeltaTime, ColorModifier(Skins[0]).Color);
}

// for FaceQuads,VoxelFaces and Lipsyncing
event mimic (int eyeX,int eyeY, int browX, int browY);
event Talk();

function Reset();

function SetDebug()
{
SetStaticMesh(DebugStaticMesh);
bUnlit=true;
Skins[0]=None;
}

defaultproperties
{
AmbientGlow=4
MaxLights=16
DrawType=DT_StaticMesh
StaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhiteCentered'
DebugStaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.AxisArrows'
Skins(0)=Material'MovieSandboxTextures.green'
drawscale=0.25
bStatic=false
bNoDelete=false
bHidden=false
bUnlit=false
CollisionRadius=8.0
CollisionHeight=8.0

//bUseCylinderCollision=true
//bCollideActors=true
bCollideActors=false
bBlockActors=False
bCollideWorld=False
bProjTarget=False
bNoRotate=false
}
