//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelPawn extends MSBPawn;

var vector MasterSize;
var array<MSBMasterBlock> Blocks;
var array<MSBsimpleBlock> MSBFaceBlock;                      //can mimic and talk

event PostBeginPlay()
{
super.PostBeginPlay();
setMSBMasterBlocks();
}

// *******************************************************************************
// Lipsyncing
// *******************************************************************************

function Talk()
{
local int i;

Log("Talking!");

for (i=0;i<MSBFaceBlock.length;i++)
  if (MSBFaceBlock[i]!=None)
    MSBFaceBlock[i].Talk();
}

function Mimic()
{
local int i;

super.Mimic();
for (i=0;i<MSBFaceBlock.length;i++)
  if (MSBFaceBlock[i]!=None)
    MSBFaceBlock[i].Mimic(eyeX, eyeY, browX, browY);
}

// *******************************************************************************
// Loading Voxels and cleaning up
// *******************************************************************************

function LoadCharacter()
{
local MSBVoxelCharacterSave char;
local class<MSBSimpleBlock> VoxelBlockClass;
local int bone,block,sps;
local MSBMasterBlock Master;
local class <MSBVoxelShader> shaderclass;
local int lowestZ;

lowestZ=100000000;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',content,"MSBVoxChar_"$content);
for(bone=0;bone<char.Parts.length;bone++)
  {
    Master=Blocks[bone];
    //get rid of old blocks
    Master.clearBlocks();
    //set new blocks
    for (block=0;block<char.Parts[bone].Col.length;block++)
      {
      if (char.Parts[bone].blockType.length<block+1)
        char.Parts[bone].blockType[block]="MSBObjects.MSBSimpleBlock";
      VoxelBlockClass=class<MSBSimpleBlock>(DynamicLoadObject(char.Parts[bone].blockType[block],class'Class'));
      Master.S[block]=Spawn(VoxelBlockClass,,,Master.Location);
      Master.S[block].Skins[0]=new() class'ColorModifier';
      ColorModifier(Master.S[block].Skins[0]).Color=char.Parts[bone].Col[block];
      ColorModifier(Master.S[block].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
      Master.S[block].SetDrawScale(char.Parts[Bone].drawScale[block]);
      Master.S[block].initialDrawScale=char.Parts[Bone].drawScale[block];
      Master.AttachToBone(Master.S[Master.S.length-1],'');
      Master.S[block].setRelativeLocation(char.Parts[bone].BlockRelLocation[block] << Master.Rotation);
      Master.S[block].Master=Master;
      if (char.Parts[bone].blockShader.Length>0 && char.Parts[bone].blockShader[block]!="")
        {
        shaderClass=class<MSBVoxelShader>(DynamicLoadObject(char.Parts[bone].blockShader[block],class'Class'));
        Master.S[block].shader= new shaderClass;
        Master.S[block].shader.Parent=Master.S[block];
        Master.S[block].shader.originalDrawScale3D=Master.S[block].DrawScale3D;
        for (sps=0;sps<Master.S[block].shader.Properties.length;sps++)
          Master.S[block].shader.SetPropertyText(Master.S[block].shader.Properties[sps],char.Parts[bone].blockShaderValues[sps]);
        }
      if (Master.S[block].IsA('MSBMouthBlock'))
        {
        Log("Found a Mouth!");
        MSBFaceBlock[MSBFaceBlock.length]=Master.S[block];
        }
//determine collisionheight
//      if (Master.S[block].Location.Z<lowestZ)
//        lowestZ=Master.S[block].Location.Z;
//      Log("Z Value:"@lowestZ@"CollHeight"@Location.Z-lowestZ);
      }
    Master.bDisplayed=false;
  }

//set talkability
if (MSBFaceBlock.Length>0 && MSBFaceBlock[0]!=None)
  bTalkable=true;

//set Collision Height
//if (Abs(Location.Z-lowestZ)>4)
// SetCollisionSize(CollisionRadius,Abs(Location.Z-lowestZ));
//else
// SetCollisionSize(CollisionRadius,4);

}

function setMSBMasterBlocks()
{
local coords C[26];
local int i;

C[0]=GetBoneCoords('Bip01');

C[1]=GetBoneCoords('Bip01 Pelvis');
C[2]=GetBoneCoords('bip01 Spine');
C[3]=GetBoneCoords('bip01 Spine1');
C[4]=GetBoneCoords('bip01 Spine2');
C[5]=GetBoneCoords('Bip01 Neck');

C[6]=GetBoneCoords('Bip01 R Clavicle');
C[7]=GetBoneCoords('Bip01 R UpperArm');
C[8]=GetBoneCoords('Bip01 R Forearm');
C[9]=GetBoneCoords('Bip01 R Hand');
C[10]=GetBoneCoords('Bip01 R Finger');
C[11]=GetBoneCoords('Bone_weapon');

C[12]=GetBoneCoords('Bip01 L Clavicle');
C[13]=GetBoneCoords('Bip01 L UpperArm');
C[14]=GetBoneCoords('Bip01 L Forearm');
C[15]=GetBoneCoords('Bip01 L Hand');
C[16]=GetBoneCoords('Bip01 L Finger');

C[17]=GetBoneCoords('bip01 R Thigh');
C[18]=GetBoneCoords('Bip01 R Calf');
C[19]=GetBoneCoords('Bip01 R Foot');
C[20]=GetBoneCoords('Bip01 R Toe0');

C[21]=GetBoneCoords('bip01 L Thigh');
C[22]=GetBoneCoords('Bip01 L Calf');
C[23]=GetBoneCoords('Bip01 L Foot');
C[24]=GetBoneCoords('Bip01 L Toe0');

C[25]=GetBoneCoords('Bip01 Head');

for (i=0;i<26;i++)
  {
  Blocks[i]=Spawn(class'MSBMasterBlock',self,,C[i].Origin);
  Blocks[i].BoneNumber=i;
  Blocks[i].P=self;
  }
}

function clearPawn()
{
local int i;

for (i=0;i<26;i++)
  {
  Blocks[i].clearBlocks();
  Blocks[i].Destroy();
  if (MSBFaceBlock.length>0)
   if (MSBFaceBlock[i]!=None)
     MSBFaceBlock[i].Destroy();
  }
}


//function string fixBrokenSaves(string broken)
//{
//local string leftPrt,rightPrt;
//broken=Caps(broken);
//if (Left(broken,1)!="0")
//  {
//  Divide(broken,"MOVIESANDBOXTEXTURES",leftPrt,rightPrt);
//  Divide(rightPrt,"MOVIESANDBOXTEXTURES",leftPrt,rightPrt);
//  if (leftPrt!="")
//    {
//    Log(leftPrt);
//    return("MOVIESANDBOXTEXTURES"$leftPrt);
//    }
//  }
//if (Left(broken,1)=="0")
//  {
//  Divide(broken,"0.",leftPrt,rightPrt);
//  Divide(rightPrt,"0.",leftPrt,rightPrt);
//  if (leftPrt!="")
//    {
//    log(leftPrt);
//    return("0."$leftPrt);
//    }
//  }
//else
//  {
//  Log(broken);
//  return(broken);
//  }
//}

DefaultProperties
{
bSkinSwap=false
bTalkable=false

bCollideActors=true
CollisionHeight=48.0
Skins(0)=Material'MovieSandboxTextures.Transparent'
Skins(1)=Material'MovieSandboxTextures.Transparent'
Skins(2)=Material'MovieSandboxTextures.Transparent'
Skins(3)=Material'MovieSandboxTextures.Transparent'
}
