//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdFullSaveButton extends MSBPropertyButtonComplex;

var MSBVoxelEdController CC;
var string saveName;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();
CC=MSBVoxelEdController(M);

Parent=self;
for (i=0;i<M.saveCharacters.length+1;i++)
  {
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";
  ButtonProperty[i]="saveName";
  if (i<M.SaveCharacters.length)
    ButtonName[i]=M.SaveCharacters[i];
  else
    ButtonName[i]="createNew";
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local MSBVoxelCharacterSave char;
local MSBMasterBlock Master;
local int i,bone, block, sps;

Master=CC.DrawBrush.Master;
char=Level.Game.CreateDataObject(class'MSBVoxelCharacterSave',saveName,"MSBVoxChar_"$saveName);

//block/Voxel related
for (bone=0;bone<CC.myReferencePawn.Blocks.length;bone++)
  {
  char.Parts.Insert(bone,1);
  Master=CC.myReferencePawn.Blocks[bone];
  if (Master!=None)
   {
   for (block=0;block<Master.S.length;block++)
    {
    char.Parts[bone].BlockRelLocation[block]=Master.S[block].RelativeLocation << Master.Rotation;
    char.Parts[bone].Col[block]=ColorModifier(Master.S[block].Skins[0]).Color;
    char.Parts[bone].drawScale[block]=Master.S[block].DrawScale;
    char.Parts[bone].blockType[block]=String(Master.S[block].class);
    if (Master.S[block]!=None && Master.S[block].shader!=None)
      {
      char.Parts[bone].blockShader[block]=String(Master.S[block].shader.Class);
      //shader property values are saved per bone!
      for (sps=0;sps<Master.S[block].shader.Properties.length;sps++)
        {
        char.Parts[bone].blockShaderValues[sps]="";
        char.Parts[bone].blockShaderValues[sps]=Master.S[block].shader.GetPropertyText(Master.S[block].shader.Properties[sps]);
        Log(char.Parts[bone].blockShaderValues[sps]);
        }
      }
    else
      char.Parts[bone].blockShader[block]="";
    }
   }
  }

Level.Game.SavePackage("MSBVoxChar_"$saveName);

//update SaveCharacters List
for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i] && i< ListButton.Length)
    M.SaveCharacters[i]=saveName;

M.SaveGeneralConfig();
}


DefaultProperties
{
tooltip="Save a Full Character"
Mat=Texture'MoviesandboxTextures.Icons.savePawn'
maxListSize=8
col=(R=255,G=255,B=255)
widthRel=30
heightRel=30
}
