//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdHud extends MSBHud;

var MSBVoxelEdController CC;
var vector chgLocAbs;
var float dTime;
var () float accel;
var vector changeHor,changeVer;

function PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
dTime=DeltaTime;
}

function PostRender(Canvas C)
{
local vector horizontal,vertical,xAxis,yAxis,zAxis,pX,pY,pZ, move;
local int i;

super.PostRender(C);

//Draw the MainMenu
if (DrawOverlays)
  {
  for (i = 0; i < Overlays.length; i++)
    Overlays[i].Render(C);
  }

//Move the MSBBlockBrush around
else
  {
  if (CC.DrawBrush!=None)
    {
    GetAxes(CC.drawBrush.Rotation,xAxis,yAxis,zAxis);
    GetAxes(CC.Rotation,pX,pY,pZ);

    if (MouseOverlay.bShiftDown)
      horizontal=zAxis*(MouseOverlay.YPos-CC.oldY);


  //yAxis major
    if (Abs(pY dot yAxis) > Abs(pY dot xAxis) && Abs(pY dot yAxis) > Abs(pY dot zAxis))
      {
      horizontal=((pY dot yAxis)*yAxis)*(MouseOverlay.xPos-CC.oldX);
      vertical=-((pZ dot zAxis)*zAxis)*(MouseOverlay.yPos-CC.oldY);

      if (MouseOverlay.bShiftDown)
        vertical=xAxis*(MouseOverlay.YPos-CC.oldY);

      changeHor+=horizontal*dTime*CC.Gridspacing*accel;
      changeVer+=vertical*dTime*CC.Gridspacing*accel;
      if (CC.bGrid)
        {
        if (MouseOverlay.bShiftDown)
          move=int((changeVer/CC.gridspacing) dot xAxis)*xAxis;
        else
          move=int((changeHor dot yAxis)/CC.gridspacing)*yAxis+int((changeVer dot zAxis)/CC.gridspacing)*zAxis;
        }
      else
        move=horizontal+vertical;
      }

  //xAxis major
    if (Abs(pY dot xAxis) > Abs(pY dot yAxis) && Abs(pY dot xAxis) > Abs(pY dot zAxis))
      {
      horizontal=((pY dot xAxis)*xAxis)*(MouseOverlay.xPos-CC.oldX);
      vertical=-((pZ dot zAxis)*zAxis)*(MouseOverlay.yPos-CC.oldY);

      if (MouseOverlay.bShiftDown)
        vertical=yAxis*(MouseOverlay.YPos-CC.oldY);

      changeHor+=horizontal*dTime*CC.Gridspacing*accel;
      changeVer+=vertical*dTime*CC.Gridspacing*accel;
      if (CC.bGrid)
        {
        if (MouseOverlay.bShiftDown)
          move=int((changeVer/CC.gridspacing) dot yAxis) * yAxis;
        else
          move=int((changeHor dot xAxis)/CC.gridspacing)*xAxis+int((changeVer dot zAxis)/CC.gridspacing)*zAxis;
        }
      else
        move=horizontal+vertical;
      }

  //zAxis major
    if (Abs(pY dot zAxis) > Abs(pY dot yAxis) && Abs(pY dot zAxis) > Abs(pY dot xAxis))
      {
      horizontal=((pY dot zAxis)*zAxis)*(MouseOverlay.xPos-CC.oldX);
      if (Abs(pZ dot xAxis)> Abs(pZ dot yAxis))
        {
        vertical=-((pZ dot xAxis)*xAxis)*(MouseOverlay.yPos-CC.oldY);
        if (MouseOverlay.bShiftDown)
          vertical=yAxis*(MouseOverlay.YPos-CC.oldY);
        }
      else
        {
        vertical=((pZ dot yAxis)*yAxis)*(MouseOverlay.yPos-CC.oldY);
        if (MouseOverlay.bShiftDown)
          vertical=xAxis*(MouseOverlay.YPos-CC.oldY);
        }

      changeHor+=horizontal*dTime*CC.Gridspacing*accel;
      changeVer+=vertical*dTime*CC.Gridspacing*accel;
      if (CC.bGrid)
        {
        if (Abs(pZ dot xAxis)> Abs(pZ dot yAxis))
          {
          if (MouseOverlay.bShiftDown)
            move=int((changeVer/CC.gridspacing) dot yAxis) * yAxis;
          else
            move=int((changeHor dot zAxis)/CC.gridspacing)*zAxis+int((changeVer dot xAxis)/CC.gridspacing)*xAxis;
          }
        else
          {
          if (MouseOverlay.bShiftDown)
            move=int((changeVer/CC.gridspacing) dot xAxis) * xAxis;
          else
            move=int((changeHor dot zAxis)/CC.gridspacing)*zAxis+int((changeVer dot yAxis)/CC.gridspacing)*yAxis;
          }
        }
      else
        move=horizontal+vertical;
      }
    if (VSize(move)>0)
      {
      changeHor=0*changeHor;
      changeVer=0*changeVer;
      }

    CC.DrawBrush.SetLocation(CC.DrawBrush.Location+move);
    MouseOverlay.xPos=CC.oldX;
    MouseOverlay.yPos=CC.oldY;
    }

  if (MouseOverlay.pressedKey==1 && CC.DrawBrush!=None && CC.bPlay && MouseOverlay.hudTargetActor==None)
    {
    CC.DrawBrush.Trigger(self,none);
    MouseOverlay.pressedKey=0;
    }
  if (MouseOverlay.pressedKey==2 && CC.DrawBrush!=None && CC.bPlay && MouseOverlay.hudTargetActor==None)
    {
    CC.DrawBrush.Trigger(none,none);
    MouseOverlay.pressedKey=0;
    }

  }
MouseOverlay.hudTargetActor=None;
}

DefaultProperties
{

MenuButtons(0)="MSBVoxelCharacterEditor.MSBMenuButtonColor";
MenuButtons(1)="MSBVoxelCharacterEditor.MSBMenuButtonBrush";
MenuButtons(2)="MSBVoxelCharacterEditor.MSBToggleMasterButton";
MenuButtons(3)="MSBVoxelCharacterEditor.MSBSwitchModeButton";
MenuButtons(4)="MSBVoxelCharacterEditor.MSBMenuButtonVoxelSystem";

drawOverlays=true
accel=5
}
